{-# LANGUAGE RankNTypes, GeneralizedNewtypeDeriving,
             DeriveFunctor, ScopedTypeVariables, KindSignatures #-}

module Tomorrow
  (Id(..), O, spin, Time(..))
  where

import Control.Applicative
import Unsafe.Coerce

class Applicative o => Time o where
  fix :: (o x -> x) -> x

class StrictlyPositive (h :: (* -> *) -> *) where

-- Only strictly positive h.
spin :: forall h. StrictlyPositive h => (forall o. Time o => h o) -> h Id
spin x = unsafeCoerce (x :: h O)

newtype Id a = Id { unId :: a }
  deriving (Show, Functor)

instance Applicative Id where
  pure = Id
  Id f <*> Id x = Id (f x)

newtype O a = O a
  deriving (Functor, Show)

instance Applicative O where
  pure        = O
  O f <*> O x = O (f x)

instance Time O where
  fix f = z
    where z = f (O z)

